//
//  AXAppSupport.h
//  MSRecEventManager
//
//  Created by Paul Herzog on 6/26/08.
//  Copyright 2008 MacSpeech, Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface AXAppSupport : NSObject {
  AXUIElementRef axAppElement;
  pid_t applicationPID;
}

- (id)initWithAppNamed:(NSString *)applicationName;
- (id)initWithAppBundleID:(NSString *)applicationBundleID;

#pragma mark -
#pragma mark Retrieve AX Attributes
- (AXUIElementRef)copyFocusedWindow;
- (NSString *)windowTitleForWindowElement:(AXUIElementRef)axWindowElement;
- (NSString *)documentNameForWindowElement:(AXUIElementRef)axWindowElement;

#pragma mark -
#pragma mark AX Utilities
- (CFIndex)countOfArrayNamed:(CFStringRef)arrayName fromElement:(AXUIElementRef)axUIElement;
- (AXUIElementRef)copyAttribute:(CFStringRef)attribute fromElement:(AXUIElementRef)axElement;
- (CFArrayRef)copyAttributeArray:(CFStringRef)attribute fromElement:(AXUIElementRef)axElement;
- (NSObject *)attributeNamed:(CFStringRef)attribute fromElement:(AXUIElementRef)axElement;
+ (NSArray *)attributeNamesForElement:(AXUIElementRef)axUIElement;

#pragma mark -
#pragma mark PID Utilities
+ (pid_t)pidForApplication:(NSString *)application;
+ (pid_t)pidForAppBundleID:(NSString *)applicationBundleID;
+ (NSString *)appNameForPid:(pid_t)pid;
+ (NSString *)appBundleIDForPid:(pid_t)pid;

@end
